(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('feature-toggle-service'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-feature-toggle', ['exports', 'feature-toggle-service', '@angular/core', '@angular/common'], factory) :
    (factory((global['ngx-feature-toggle'] = {}),global.FeatureToggleService,global.ng.core,global.ng.common));
}(this, (function (exports,featureToggleService,core,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleDirective = /** @class */ (function () {
        function FeatureToggleDirective(templateRef, viewContainer) {
            this.templateRef = templateRef;
            this.viewContainer = viewContainer;
            this.isOn = false;
        }
        /**
         * @return {?}
         */
        FeatureToggleDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (!this.featureToggle) {
                    throw new Error('Attribute `featureToggle` should not be null or empty');
                }
                this.shouldRender();
            };
        /**
         * @return {?}
         */
        FeatureToggleDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                if (this.isOn !== featureToggleService.isOn(this.featureToggle)) {
                    this.shouldRender();
                }
            };
        /**
         * @private
         * @return {?}
         */
        FeatureToggleDirective.prototype.shouldRender = /**
         * @private
         * @return {?}
         */
            function () {
                this.isOn = featureToggleService.isOn(this.featureToggle);
                if (this.isOn) {
                    this.viewContainer.createEmbeddedView(this.templateRef);
                }
                else {
                    this.viewContainer.clear();
                }
            };
        FeatureToggleDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[featureToggle]',
                    },] }
        ];
        /** @nocollapse */
        FeatureToggleDirective.ctorParameters = function () {
            return [
                { type: core.TemplateRef },
                { type: core.ViewContainerRef }
            ];
        };
        FeatureToggleDirective.propDecorators = {
            featureToggle: [{ type: core.Input }]
        };
        return FeatureToggleDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleWhenDisabledDirective = /** @class */ (function () {
        function FeatureToggleWhenDisabledDirective(templateRef, viewContainer) {
            this.templateRef = templateRef;
            this.viewContainer = viewContainer;
            this.isOn = false;
        }
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (!this.featureToggleWhenDisabled) {
                    throw new Error('Attribute `featureToggleWhenDisabled` should not be null or empty');
                }
                this.shouldRender();
            };
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                if (this.isOn !== featureToggleService.isOn(this.featureToggleWhenDisabled)) {
                    this.shouldRender();
                }
            };
        /**
         * @return {?}
         */
        FeatureToggleWhenDisabledDirective.prototype.shouldRender = /**
         * @return {?}
         */
            function () {
                this.isOn = featureToggleService.isOn(this.featureToggleWhenDisabled);
                if (!this.isOn) {
                    this.viewContainer.createEmbeddedView(this.templateRef);
                }
                else {
                    this.viewContainer.clear();
                }
            };
        FeatureToggleWhenDisabledDirective.decorators = [
            { type: core.Directive, args: [{
                        // tslint:disable-next-line: directive-selector
                        selector: '[featureToggleWhenDisabled]',
                    },] }
        ];
        /** @nocollapse */
        FeatureToggleWhenDisabledDirective.ctorParameters = function () {
            return [
                { type: core.TemplateRef },
                { type: core.ViewContainerRef }
            ];
        };
        FeatureToggleWhenDisabledDirective.propDecorators = {
            featureToggleWhenDisabled: [{ type: core.Input }]
        };
        return FeatureToggleWhenDisabledDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleProviderComponent = /** @class */ (function () {
        function FeatureToggleProviderComponent() {
            this.features = {};
            this.currentConfig = {};
        }
        /**
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                if (typeof this.features !== 'object') {
                    throw new Error('Attribute `features` should not be null or empty');
                }
                this.setFeatureToggles();
            };
        /**
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                this.setFeatureToggles();
            };
        /**
         * @private
         * @return {?}
         */
        FeatureToggleProviderComponent.prototype.setFeatureToggles = /**
         * @private
         * @return {?}
         */
            function () {
                if (this.currentConfig !== this.features) {
                    this.currentConfig = this.features;
                    featureToggleService.set(this.features);
                }
            };
        FeatureToggleProviderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'feature-toggle-provider',
                        template: "\n    <ng-content></ng-content>\n  "
                    }] }
        ];
        FeatureToggleProviderComponent.propDecorators = {
            features: [{ type: core.Input }]
        };
        return FeatureToggleProviderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FeatureToggleModule = /** @class */ (function () {
        function FeatureToggleModule() {
        }
        FeatureToggleModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                        exports: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                        imports: [common.CommonModule],
                    },] }
        ];
        return FeatureToggleModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.FeatureToggleDirective = FeatureToggleDirective;
    exports.FeatureToggleWhenDisabledDirective = FeatureToggleWhenDisabledDirective;
    exports.FeatureToggleProviderComponent = FeatureToggleProviderComponent;
    exports.FeatureToggleModule = FeatureToggleModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-feature-toggle.umd.js.map