import { isOn, set } from 'feature-toggle-service';
import { Directive, Input, TemplateRef, ViewContainerRef, Component, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleDirective = /** @class */ (function () {
    function FeatureToggleDirective(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.isOn = false;
    }
    /**
     * @return {?}
     */
    FeatureToggleDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.featureToggle) {
            throw new Error('Attribute `featureToggle` should not be null or empty');
        }
        this.shouldRender();
    };
    /**
     * @return {?}
     */
    FeatureToggleDirective.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        if (this.isOn !== isOn(this.featureToggle)) {
            this.shouldRender();
        }
    };
    /**
     * @private
     * @return {?}
     */
    FeatureToggleDirective.prototype.shouldRender = /**
     * @private
     * @return {?}
     */
    function () {
        this.isOn = isOn(this.featureToggle);
        if (this.isOn) {
            this.viewContainer.createEmbeddedView(this.templateRef);
        }
        else {
            this.viewContainer.clear();
        }
    };
    FeatureToggleDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[featureToggle]',
                },] }
    ];
    /** @nocollapse */
    FeatureToggleDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    FeatureToggleDirective.propDecorators = {
        featureToggle: [{ type: Input }]
    };
    return FeatureToggleDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleWhenDisabledDirective = /** @class */ (function () {
    function FeatureToggleWhenDisabledDirective(templateRef, viewContainer) {
        this.templateRef = templateRef;
        this.viewContainer = viewContainer;
        this.isOn = false;
    }
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (!this.featureToggleWhenDisabled) {
            throw new Error('Attribute `featureToggleWhenDisabled` should not be null or empty');
        }
        this.shouldRender();
    };
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        if (this.isOn !== isOn(this.featureToggleWhenDisabled)) {
            this.shouldRender();
        }
    };
    /**
     * @return {?}
     */
    FeatureToggleWhenDisabledDirective.prototype.shouldRender = /**
     * @return {?}
     */
    function () {
        this.isOn = isOn(this.featureToggleWhenDisabled);
        if (!this.isOn) {
            this.viewContainer.createEmbeddedView(this.templateRef);
        }
        else {
            this.viewContainer.clear();
        }
    };
    FeatureToggleWhenDisabledDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line: directive-selector
                    selector: '[featureToggleWhenDisabled]',
                },] }
    ];
    /** @nocollapse */
    FeatureToggleWhenDisabledDirective.ctorParameters = function () { return [
        { type: TemplateRef },
        { type: ViewContainerRef }
    ]; };
    FeatureToggleWhenDisabledDirective.propDecorators = {
        featureToggleWhenDisabled: [{ type: Input }]
    };
    return FeatureToggleWhenDisabledDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleProviderComponent = /** @class */ (function () {
    function FeatureToggleProviderComponent() {
        this.features = {};
        this.currentConfig = {};
    }
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (typeof this.features !== 'object') {
            throw new Error('Attribute `features` should not be null or empty');
        }
        this.setFeatureToggles();
    };
    /**
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.ngDoCheck = /**
     * @return {?}
     */
    function () {
        this.setFeatureToggles();
    };
    /**
     * @private
     * @return {?}
     */
    FeatureToggleProviderComponent.prototype.setFeatureToggles = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.currentConfig !== this.features) {
            this.currentConfig = this.features;
            set(this.features);
        }
    };
    FeatureToggleProviderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'feature-toggle-provider',
                    template: "\n    <ng-content></ng-content>\n  "
                }] }
    ];
    FeatureToggleProviderComponent.propDecorators = {
        features: [{ type: Input }]
    };
    return FeatureToggleProviderComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var FeatureToggleModule = /** @class */ (function () {
    function FeatureToggleModule() {
    }
    FeatureToggleModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                    exports: [FeatureToggleProviderComponent, FeatureToggleDirective, FeatureToggleWhenDisabledDirective],
                    imports: [CommonModule],
                },] }
    ];
    return FeatureToggleModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FeatureToggleDirective, FeatureToggleWhenDisabledDirective, FeatureToggleProviderComponent, FeatureToggleModule };

//# sourceMappingURL=ngx-feature-toggle.js.map